"use strict";
/*---------------------------------------------------------------------------------------------
 * Copyright (c) Bentley Systems, Incorporated. All rights reserved.
 * See LICENSE.md in the project root for license terms and full copyright notice.
 *--------------------------------------------------------------------------------------------*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorBoundary = void 0;
const react_1 = __importStar(require("react"));
const Fallback_1 = require("./Fallback");
class ErrorBoundary extends react_1.Component {
    constructor(props) {
        super(props);
        this.state = {
            fallback: false,
            error: new Error(),
        };
    }
    static getDerivedStateFromError(e) {
        return {
            fallback: true,
            error: e,
        };
    }
    render() {
        var _a;
        if (this.state.fallback) {
            const Component = (_a = this.props.Fallback) !== null && _a !== void 0 ? _a : Fallback_1.Fallback;
            return (react_1.default.createElement(Component, { message: this.state.error.message, eventTracker: this.props.eventTracker, eventTitle: this.props.eventTitle }));
        }
        else {
            return react_1.default.createElement(react_1.Fragment, null, this.props.children);
        }
    }
}
exports.ErrorBoundary = ErrorBoundary;
//# sourceMappingURL=ErrorBoundary.js.map