"use strict";
/*---------------------------------------------------------------------------------------------
 * Copyright (c) Bentley Systems, Incorporated. All rights reserved.
 * See LICENSE.md in the project root for license terms and full copyright notice.
 *--------------------------------------------------------------------------------------------*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Fallback = void 0;
const react_1 = __importStar(require("react"));
const react_i18next_1 = require("react-i18next");
const FallbackUi_1 = require("../components/fallback/FallbackUi");
const _401_9ZUI_WEB_svg_1 = __importDefault(require("../images/svgs/401-9ZUI-WEB.svg"));
const _403_9ZUI_WEB_svg_1 = __importDefault(require("../images/svgs/403-9ZUI-WEB.svg"));
const _404_WEB_svg_1 = __importDefault(require("../images/svgs/404-WEB.svg"));
const _500_WEB_svg_1 = __importDefault(require("../images/svgs/500-WEB.svg"));
const _503_WEB_svg_1 = __importDefault(require("../images/svgs/503-WEB.svg"));
const Generic_WEB_svg_1 = __importDefault(require("../images/svgs/Generic-WEB.svg"));
const i18n_1 = require("../util/i18n");
exports.Fallback = ({ translate = true, message, className, eventTracker: trackEvent, eventTitle, withHelmet, alternateI18n, }) => {
    const { t } = react_i18next_1.useTranslation(undefined, { i18n: i18n_1.iTwinErrorI18n });
    const { t: alternateT } = react_i18next_1.useTranslation(undefined, { i18n: alternateI18n });
    react_1.useEffect(() => {
        if ((trackEvent && !eventTitle) || (!trackEvent && eventTitle)) {
            console.warn("itwin-error-handling-react Fallback: Both trackEvent and eventTitle must be provided for tracking to occur, remove both if no tracking is wanted.");
        }
    }, [trackEvent, eventTitle]);
    let src = Generic_WEB_svg_1.default;
    let alt = "Generic Error SVG";
    let title = "An Error Has Occurred";
    let text = "";
    if (message) {
        if (translate && i18n_1.iTwinErrorI18n.exists(message)) {
            title = t("fallbackTitleGen");
            alt = t("fallbackAltGen");
            text = t(message);
            switch (message) {
                case "error401":
                    title = t("fallbackTitle401");
                    alt = t("fallbackAlt401");
                    src = _401_9ZUI_WEB_svg_1.default;
                    break;
                case "error403":
                case "ErrorNoEntitlement":
                    title = t("fallbackTitle403");
                    alt = t("fallbackAlt403");
                    src = _403_9ZUI_WEB_svg_1.default;
                    break;
                case "error404":
                    title = t("fallbackTitle404");
                    alt = t("fallbackAlt404");
                    src = _404_WEB_svg_1.default;
                    break;
                case "error500":
                    title = t("fallbackTitle500");
                    alt = t("fallbackAlt500");
                    src = _500_WEB_svg_1.default;
                    break;
                case "error503":
                case "ConnectFailed":
                    title = t("fallbackTitle503");
                    alt = t("fallbackAlt503");
                    src = _503_WEB_svg_1.default;
                    break;
                case "MaintenanceMode":
                    title = t("fallbackTitle503");
                    alt = t("fallbackAlt503");
                    src = _503_WEB_svg_1.default;
                    break;
                case "errorUnsupportedBrowser":
                    title = t("fallbackTitleUnsupportedBrowser");
                    alt = t("fallbackAltUnsupportedBrowser");
                    break;
                case "errorLoginFailed":
                    title = t("errorLoginFailed");
                    text = t("loginValidationFailed");
                    break;
                default:
                    title = t("fallbackTitleDefault");
                    alt = t("fallbackAltDefault");
                    src = _404_WEB_svg_1.default;
                    text = t("errorDefault");
                    message = "errorDefault";
                    break;
            }
        }
        else if (translate && (alternateI18n === null || alternateI18n === void 0 ? void 0 : alternateI18n.exists(message))) {
            title = t("fallbackTitleGen");
            alt = t("fallbackAltGen");
            text = alternateT(message);
        }
        else {
            text = message;
        }
        if (trackEvent && eventTitle) {
            trackEvent(eventTitle, { error: message });
        }
    }
    return (react_1.default.createElement(FallbackUi_1.FallbackUi, { text: text, title: title, imageSource: src, imageAlt: alt, className: className, withHelmet: withHelmet }));
};
//# sourceMappingURL=Fallback.js.map